
signature COMPILE = sig
val compile : Fiacre.Fiacre -> unit
end;

structure Compile : COMPILE = struct

fun compile p = 
    (printVerbose "::Compilation to tts\n";
     let val result =
	     (Emit.emit o 
	      Optimize.optimize o
	      PostCompose.postcompose o 
	      Compose.compose o 
	      ToTTS.toTTS) p
     in printVerbose "::Done\n";
	result
     end);

(*
fun compile p = 
    (printVerbose "::Compilation to tts\n";
     let val result =
	     let val p1 = ToTTS.toTTS p
	     in printVerbose "::composing\n";
		let val p2 = Compose.compose p1
		in printVerbose "::postcomposing\n";
		   let val p3 = PostCompose.postcompose p2
		   in printVerbose "::emitting\n";
		      Emit.emit p3
		   end
		end
	     end
     in printVerbose "::Done\n";
	result
     end);
*)

end
